#########################################################
###                  Summarize                        ###
#########################################################

shared.dir <- Sys.getenv("shared_folder")
index.file <- paste0(shared.dir, "/html/index.html")

# definition of table files, titles and descriptions
table.files <- c("ChIPQC_summary_table.txt", "MFD_statistics_table.txt")
table.names <- c("ChIPQC Summary Table", "Mapping Summary Table")
table.desc <- c("This table contains a summary of filtering and quality metrics generated by the ChIPQC package.",
				"This table shows the absolute number of total, mapped, passing MapQ filter and duplicated reads. The percent of mapped reads passing quality filter and marked as duplicates (Non-Redundant Fraction) are also included.")

# definition of image files, titles and descriptions
image.files <- c("CCPlot.png", "CoverageHistogramPlot.png", "PeakProfile.png", "GenomicFeatureEnrichment.png", "Rip.png", "Rap.png", "Ribl.png", "PeakCorHeatmap.png", "PeakPCA.png")
image.names <- c("Cross-Coverage Plot", "Coverage Histogram Plot", "Peak Profile Plot", "Genomic Feature Enrichment Heatmap", "Bar Chart of Reads in Peaks", "Box Plot of Reads in Peaks", "Bar Chart of Reads in Blacklisted Regions", "Peak Correlation Heatmap", "Peak PCA Plot")
image.desc <- c("This figure shows the CCov_Score after successive shifts. The point of highest score is considered the fragment length.",
			    "This figure shows the number of genomic positions as a function of the read depth. A higher number of genomic positions with large pileups is expected for ChIP samples. Hence, the respective curves should be characterized by broader tails.",
				"This figure represents the mean read depth across and around peaks. By identifying the average pattern of enrichment across peaks, differences in both mean peak height and shape may be found. This not only assists in a better characterisation of ChIP enrichment but can aid in the identification of outliers.",
			    "This figure shows the log2 enrichment of specified genomic features within samples with regions of greater enrichment showing bright yellow and lower enrichment seen in black.",
				"This figure shows the total percentage of reads contained within enriched regions or peaks. The higher efficiency ChIP-Seq will show a higher percentage of reads in enriched regions/peaks and longer epigenetic marks will often have a higher ranges of efficiencies than punctate marks or transcription factors.",
				"This figure shows the distribution of reads in all peaks. Evaluation of the distibution can allow for greater characteriation of the variability and range of signal in peaks within a sample and so better characterise the signal across peaks than the RIP score may allow.",
				"This figure shows the total percentage of reads contained within blacklisted regions.",
				"This figure shows the correlation between samples as a heatmap. Replicate samples of high quality can be expected to cluster together in the heatmap.",
				"This figure shows the correlation between samples by principal component analysis. Replicate samples of high quality can be expected to be spatially grouped within the PCA plot.")

# generate HTML code for inclusion of table titles and captions
table.titles <- paste0("<h2>", table.names, "</h2>")
table.captions <- paste0("<p>", table.desc, "</p>")
names(table.titles) <- table.files
names(table.captions) <- table.files

# generate HTML code for inclusion of figure titles and captions
image.titles <- paste0("<h2>", image.names, "</h2>")
image.captions <- paste0("<p>", image.desc, "</p>")
names(image.titles) <- image.files
names(image.captions) <- image.files

html.content <- "<html><head><title></title></head><body>\n"
html.content <- paste0(html.content, "<p>This report was generated with ChIPQC version ", packageVersion("ChIPQC"), ".</p>\n")

# include tables into HTML report (if the respective files exist)
for (table in table.files) {
	table.file <- paste0(shared.dir, "/html/", table)
	if (file.exists(table.file)) {
		curr.table <- as.matrix(read.table(table.file, sep="\t", header=T, check.names=F))
		html.content <- paste0(html.content, table.titles[table], "\n")
		html.content <- paste0(html.content, table.captions[table], "\n")
		html.content <- paste0(html.content, "<table>\n")
		html.content <-  paste0(html.content, "<tr>", paste("<th>", colnames(curr.table), "</th>", collapse=""), "</tr>\n")
		for (i in 1:nrow(curr.table)) {
			html.content <-  paste0(html.content, "<tr>", paste("<td>", curr.table[i,], "</td>", collapse=""), "</tr>\n")
		}
		html.content <- paste0(html.content, "</table>\n")
	}
}

# include images into HTML report (if the respective files exist)
for (image in image.files) {
	image.file <- paste0(shared.dir, "/html/", image)
 	if (file.exists(image.file)) {
 		html.content <- paste0(html.content, "<img src=\"", image, "\" </img>\n")
 		html.content <- paste0(html.content, image.titles[image], "\n")
       	html.content <- paste0(html.content, image.captions[image], "\n")
 	}
}
html.content <- paste0(html.content, "</body></html>\n")

cat(html.content, file=index.file)

# sample annotation with qc columns
chip.table.file <- paste0(shared.dir, "/html/", "ChIPQC_summary_table.txt")
mfd.table.file <- paste0(shared.dir, "/html/", "MFD_statistics_table.txt")

if (file.exists(chip.table.file) && file.exists(mfd.table.file)) {
	new.chip.colnames <- c("Predicted Fragment Length [QC]", "Relative Cross-Coverage Score [QC]", "Standardised Standard Deviation [QC]", "Reads Mapped To Peaks [%] [QC]")
	new.mfd.colnames <- c("Read Duplicates [%] [QC]", "Reads Passing MapQ Filter [%] [QC]", "Duplicated Reads Passing MapQ Filter [%] [QC]")
	chip.colnames <- c("ID", "FragL", "RelCC", "SSD", "RiP%")
	full.chip.table <- read.table(chip.table.file, sep="\t", header=T, check.names=F)
	if ("RiBL%" %in% colnames(full.chip.table)) {
		chip.colnames <- c(chip.colnames, "RiBL%")
		new.chip.colnames <- c(new.chip.colnames, "Reads Mapped To Blacklist [%] [QC]")
	}
	chip.table <- as.matrix(full.chip.table[, chip.colnames])
	mfd.table <- as.matrix(read.table(mfd.table.file, sep="\t", header=T, check.names=F)[, c("Total Dup%", "Pass MapQ Filter%", "Pass MapQ Filter and Dup%")])
	merged.table <- cbind(chip.table, mfd.table)
	colnames(merged.table) <- c("Name", new.chip.colnames, new.mfd.colnames)

	# add possible missed samples (e.g. controls without case)
	sample.anno <- as.matrix(read.csv(Sys.getenv("sample_annotation_0"), header=T, sep = "\t", row.names=1, check.names=F))
	rownames(sample.anno) <- gsub("[ -]", "_", rownames(sample.anno))
	diff <- setdiff(rownames(sample.anno), merged.table[,1])
	na.template <- rep("NA", ncol(merged.table))
	for(s in diff) {
		na.template[1] <- s
		merged.table <- rbind(merged.table, na.template)
	}

	write.table(merged.table, file=paste(shared.dir, "0_sample_annotation_output.txt", sep="/"), sep="\t", row.names=F, col.names=T, quote=F)
}